OpenShot Audio Library | OpenShotAudio: juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse > Class Template Reference

OpenShot Audio Library | OpenShotAudio 0.3.0

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Public Attributes | List of all members
juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse > Class Template Reference

`#include <juce_OwnedArray.h>`

## Public Types
using | ScopedLockType = typename TypeOfCriticalSectionToUse::ScopedLockType

## Public Member Functions
| OwnedArray ()=default
| ~OwnedArray ()
| OwnedArray (OwnedArray &&other) noexcept
| OwnedArray (const std::initializer_list< ObjectClass * > &items)
OwnedArray & | operator= (OwnedArray &&other) noexcept
template<class OtherObjectClass , class OtherCriticalSection >
| OwnedArray (OwnedArray< OtherObjectClass, OtherCriticalSection > &&other) noexcept
template<class OtherObjectClass , class OtherCriticalSection >
OwnedArray & | operator= (OwnedArray< OtherObjectClass, OtherCriticalSection > &&other) noexcept
void | clear (bool deleteObjects=true)
void | clearQuick (bool deleteObjects)
int | size () const noexcept
bool | isEmpty () const noexcept
ObjectClass * | operator[] (int index) const noexcept
ObjectClass * | getUnchecked (int index) const noexcept
ObjectClass * | getFirst () const noexcept
ObjectClass * | getLast () const noexcept
ObjectClass ** | getRawDataPointer () noexcept
ObjectClass ** | begin () noexcept
ObjectClass *const * | begin () const noexcept
ObjectClass ** | end () noexcept
ObjectClass *const * | end () const noexcept
ObjectClass ** | data () noexcept
ObjectClass *const * | data () const noexcept
int | indexOf (const ObjectClass *objectToLookFor) const noexcept
bool | contains (const ObjectClass *objectToLookFor) const noexcept
ObjectClass * | add (ObjectClass *newObject)
ObjectClass * | add (std::unique_ptr< ObjectClass > newObject)
ObjectClass * | insert (int indexToInsertAt, ObjectClass *newObject)
ObjectClass * | insert (int indexToInsertAt, std::unique_ptr< ObjectClass > newObject)
void | insertArray (int indexToInsertAt, ObjectClass *const *newObjects, int numberOfElements)
ObjectClass * | set (int indexToChange, ObjectClass *newObject, bool deleteOldElement=true)
ObjectClass * | set (int indexToChange, std::unique_ptr< ObjectClass > newObject, bool deleteOldElement=true)
template<class OtherArrayType >
void | addArray (const OtherArrayType &arrayToAddFrom, int startIndex=0, int numElementsToAdd=-1)
template<typename OtherArrayType >
void | addArray (const std::initializer_list< OtherArrayType > &items)
template<class OtherArrayType >
void | addCopiesOf (const OtherArrayType &arrayToAddFrom, int startIndex=0, int numElementsToAdd=-1)
template<class ElementComparator >
int | addSorted (ElementComparator &comparator, ObjectClass *newObject) noexcept
template<typename ElementComparator >
int | indexOfSorted (ElementComparator &comparator, const ObjectClass *objectToLookFor) const noexcept
void | remove (int indexToRemove, bool deleteObject=true)
ObjectClass * | removeAndReturn (int indexToRemove)
void | removeObject (const ObjectClass *objectToRemove, bool deleteObject=true)
void | removeRange (int startIndex, int numberToRemove, bool deleteObjects=true)
void | removeLast (int howManyToRemove=1, bool deleteObjects=true)
void | swap (int index1, int index2) noexcept
void | move (int currentIndex, int newIndex) noexcept
template<class OtherArrayType >
void | swapWith (OtherArrayType &otherArray) noexcept
void | minimiseStorageOverheads () noexcept
void | ensureStorageAllocated (int minNumElements) noexcept
template<class ElementComparator >
void | sort (ElementComparator &comparator, bool retainOrderOfEquivalentItems=false) noexcept
const TypeOfCriticalSectionToUse & | getLock () const noexcept

## Public Attributes
JUCE_DEPRECATED_WITH_BODY(void swapWithArray(OwnedArray &other) noexcept, { swapWith(other);}) private void | deleteAllObjects ()

## Detailed Description

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>
class juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >

An array designed for holding objects.

This holds a list of pointers to objects, and will automatically delete the objects when they are removed from the array, or when the array is itself deleted.

Declare it in the form: OwnedArray<MyObjectClass>

..and then add new objects, e.g. myOwnedArray.add (new MyObjectClass());

After adding objects, they are 'owned' by the array and will be deleted when removed or replaced.

To make all the array's methods thread-safe, pass in "CriticalSection" as the templated TypeOfCriticalSectionToUse parameter, instead of the default DummyCriticalSection.

See also
  Array, ReferenceCountedArray, StringArray, CriticalSection

Definition at line 50 of file juce_OwnedArray.h.

## Member Typedef Documentation

## ◆ ScopedLockType

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

using juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::ScopedLockType = typename TypeOfCriticalSectionToUse::ScopedLockType

Returns the type of scoped lock to use for locking this array

Definition at line 842 of file juce_OwnedArray.h.

## Constructor & Destructor Documentation

## ◆ OwnedArray() [1/4]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::OwnedArray | ( |  | ) |
| default

Creates an empty array.

## ◆ ~OwnedArray()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::~OwnedArray | ( |  | ) |
| inline

Deletes the array and also deletes any objects inside it.

To get rid of the array without deleting its objects, use its clear (false) method before deleting it.

Definition at line 62 of file juce_OwnedArray.h.

## ◆ OwnedArray() [2/4]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::OwnedArray | ( | OwnedArray< ObjectClass, TypeOfCriticalSectionToUse > && | other | ) |
| inlinenoexcept

Move constructor.

Definition at line 68 of file juce_OwnedArray.h.

## ◆ OwnedArray() [3/4]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::OwnedArray | ( | const std::initializer_list< ObjectClass * > & | items | ) |
| inline

Creates an array from a list of objects.

Definition at line 74 of file juce_OwnedArray.h.

## ◆ OwnedArray() [4/4]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>
template<class OtherObjectClass , class OtherCriticalSection >

juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::OwnedArray | ( | OwnedArray< OtherObjectClass, OtherCriticalSection > && | other | ) |
| inlinenoexcept

Converting move constructor.

Definition at line 90 of file juce_OwnedArray.h.

## Member Function Documentation

## ◆ add() [1/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass * juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::add | ( | ObjectClass * | newObject | ) |
| inline

Appends a new object to the end of the array.

Note that this object will be deleted by the OwnedArray when it is removed, so be careful not to delete it somewhere else.

Also be careful not to add the same object to the array more than once, as this will obviously cause deletion of dangling pointers.

Parameters

  newObject | the new object to add to the array

Returns
  the new object that was added

See also
  set, insert, addSorted

Definition at line 294 of file juce_OwnedArray.h.

Referenced by juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::add(), and juce::MixerAudioSource::removeAllInputs().

## ◆ add() [2/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass * juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::add | ( | std::unique_ptr< ObjectClass > | newObject | ) |
| inline

Appends a new object to the end of the array.

Note that this object will be deleted by the OwnedArray when it is removed, so be careful not to delete it somewhere else.

Also be careful not to add the same object to the array more than once, as this will obviously cause deletion of dangling pointers.

Parameters

  newObject | the new object to add to the array

Returns
  the new object that was added

See also
  set, insert, addSorted

Definition at line 313 of file juce_OwnedArray.h.

## ◆ addArray() [1/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>
template<class OtherArrayType >

void juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::addArray | ( | const OtherArrayType & | arrayToAddFrom,
|  | int | startIndex = `0`,
|  | int | numElementsToAdd = `-1`
| ) |  |
| inline

Adds elements from another array to the end of this array.

Parameters

  arrayToAddFrom | the array from which to copy the elements
  startIndex | the first element of the other array to start copying from
  numElementsToAdd | how many elements to add from the other array. If this value is negative or greater than the number of available elements, all available elements will be copied.

See also
  add

Definition at line 466 of file juce_OwnedArray.h.

Referenced by juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::OwnedArray().

## ◆ addArray() [2/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>
template<typename OtherArrayType >

void juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::addArray | ( | const std::initializer_list< OtherArrayType > & | items | ) |
| inline

Adds elements from another array to the end of this array.

Definition at line 477 of file juce_OwnedArray.h.

## ◆ addCopiesOf()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>
template<class OtherArrayType >

void juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::addCopiesOf | ( | const OtherArrayType & | arrayToAddFrom,
|  | int | startIndex = `0`,
|  | int | numElementsToAdd = `-1`
| ) |  |
| inline

Adds copies of the elements in another array to the end of this array.

The other array must be either an OwnedArray of a compatible type of object, or an Array containing pointers to the same kind of object. The objects involved must provide a copy constructor, and this will be used to create new copies of each element, and add them to this array.

Parameters

  arrayToAddFrom | the array from which to copy the elements
  startIndex | the first element of the other array to start copying from
  numElementsToAdd | how many elements to add from the other array. If this value is negative or greater than the number of available elements, all available elements will be copied.

See also
  add

Definition at line 498 of file juce_OwnedArray.h.

## ◆ addSorted()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>
template<class ElementComparator >

int juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::addSorted | ( | ElementComparator & | comparator,
|  | ObjectClass * | newObject
| ) |  |
| inlinenoexcept

Inserts a new object into the array assuming that the array is sorted.

This will use a comparator to find the position at which the new object should go. If the array isn't sorted, the behaviour of this method will be unpredictable.

Parameters

  comparator | the comparator to use to compare the elements - see the sort method for details about this object's structure
  newObject | the new object to insert to the array

Returns
  the index at which the new object was added

See also
  add, sort, indexOfSorted

Definition at line 534 of file juce_OwnedArray.h.

## ◆ begin() [1/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass *const * juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::begin | ( |  | ) | const
| inlinenoexcept

Returns a pointer to the first element in the array. This method is provided for compatibility with standard C++ iteration mechanisms.

Definition at line 209 of file juce_OwnedArray.h.

## ◆ begin() [2/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass ** juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::begin | ( |  | ) |
| inlinenoexcept

Returns a pointer to the first element in the array. This method is provided for compatibility with standard C++ iteration mechanisms.

Definition at line 201 of file juce_OwnedArray.h.

Referenced by juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::data(), and juce::ZipFile::sortEntriesByFilename().

## ◆ clear()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::clear | ( | bool | deleteObjects = `true` | ) |
| inline

Clears the array, optionally deleting the objects inside it first.

Definition at line 107 of file juce_OwnedArray.h.

Referenced by juce::UndoManager::clearUndoHistory(), juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeLast(), and juce::ZipFile::~ZipFile().

## ◆ clearQuick()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::clearQuick | ( | bool | deleteObjects | ) |
| inline

Clears the array, optionally deleting the objects inside it first.

Definition at line 116 of file juce_OwnedArray.h.

Referenced by juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::clear().

## ◆ contains()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

bool juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::contains | ( | const ObjectClass * | objectToLookFor | ) | const
| inlinenoexcept

Returns true if the array contains a specified object.

Parameters

  objectToLookFor | the object to look for

Returns
  true if the object is in the array

Definition at line 269 of file juce_OwnedArray.h.

## ◆ data() [1/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass *const * juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::data | ( |  | ) | const
| inlinenoexcept

Returns a pointer to the first element in the array. This method is provided for compatibility with the standard C++ containers.

Definition at line 241 of file juce_OwnedArray.h.

## ◆ data() [2/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass ** juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::data | ( |  | ) |
| inlinenoexcept

Returns a pointer to the first element in the array. This method is provided for compatibility with the standard C++ containers.

Definition at line 233 of file juce_OwnedArray.h.

## ◆ end() [1/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass *const * juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::end | ( |  | ) | const
| inlinenoexcept

Returns a pointer to the element which follows the last element in the array. This method is provided for compatibility with standard C++ iteration mechanisms.

Definition at line 225 of file juce_OwnedArray.h.

## ◆ end() [2/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass ** juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::end | ( |  | ) |
| inlinenoexcept

Returns a pointer to the element which follows the last element in the array. This method is provided for compatibility with standard C++ iteration mechanisms.

Definition at line 217 of file juce_OwnedArray.h.

Referenced by juce::ZipFile::sortEntriesByFilename().

## ◆ ensureStorageAllocated()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::ensureStorageAllocated | ( | int | minNumElements | ) |
| inlinenoexcept

Increases the array's internal storage to hold a minimum number of elements.

Calling this before adding a large known number of elements means that the array won't have to keep dynamically resizing itself as the elements are added, and it'll therefore be more efficient.

Definition at line 788 of file juce_OwnedArray.h.

## ◆ getFirst()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass * juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getFirst | ( |  | ) | const
| inlinenoexcept

Returns a pointer to the first object in the array.

This will return a null pointer if the array's empty.

See also
  getLast

Definition at line 171 of file juce_OwnedArray.h.

## ◆ getLast()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass * juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getLast | ( |  | ) | const
| inlinenoexcept

Returns a pointer to the last object in the array.

This will return a null pointer if the array's empty.

See also
  getFirst

Definition at line 182 of file juce_OwnedArray.h.

## ◆ getLock()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

const TypeOfCriticalSectionToUse & juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getLock | ( |  | ) | const
| inlinenoexcept

Returns the CriticalSection that locks this array. To lock, you can call getLock().enter() and getLock().exit(), or preferably use an object of ScopedLockType as an RAII lock for it.

Definition at line 839 of file juce_OwnedArray.h.

Referenced by juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::add(), juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::addArray(), juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::addCopiesOf(), juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::addSorted(), juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::clear(), juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::clearQuick(), juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::contains(), juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::ensureStorageAllocated(), juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getFirst(), juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getLast(), juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getUnchecked(), juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::indexOf(), juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::indexOfSorted(), juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::insert(), juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::insertArray(), juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::minimiseStorageOverheads(), juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::move(), juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::operator=(), juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::operator[](), juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::remove(), juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeAndReturn(), juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeLast(), juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeObject(), juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeRange(), juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::set(), juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::sort(), juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::swap(), and juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::swapWith().

## ◆ getRawDataPointer()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass ** juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getRawDataPointer | ( |  | ) |
| inlinenoexcept

Returns a pointer to the actual array data. This pointer will only be valid until the next time a non-const method is called on the array.

Definition at line 192 of file juce_OwnedArray.h.

## ◆ getUnchecked()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass * juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getUnchecked | ( | int | index | ) | const
| inlinenoexcept

Returns a pointer to the object at this index in the array, without checking whether the index is in-range.

This is a faster and less safe version of operator[] which doesn't check the index passed in, so it can be used when you're sure the index is always going to be legal.

Definition at line 160 of file juce_OwnedArray.h.

Referenced by juce::ZipFile::createStreamForEntry(), juce::MixerAudioSource::removeAllInputs(), and juce::ZipFile::uncompressEntry().

## ◆ indexOf()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

int juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::indexOf | ( | const ObjectClass * | objectToLookFor | ) | const
| inlinenoexcept

Finds the index of an object which might be in the array.

Parameters

  objectToLookFor | the object to look for

Returns
  the index at which the object was found, or -1 if it's not found

Definition at line 252 of file juce_OwnedArray.h.

## ◆ indexOfSorted()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>
template<typename ElementComparator >

int juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::indexOfSorted | ( | ElementComparator & | comparator,
|  | const ObjectClass * | objectToLookFor
| ) |  | const
| inlinenoexcept

Finds the index of an object in the array, assuming that the array is sorted.

This will use a comparator to do a binary-chop to find the index of the given element, if it exists. If the array isn't sorted, the behaviour of this method will be unpredictable.

Parameters

  comparator | the comparator to use to compare the elements - see the sort() method for details about the form this object should take
  objectToLookFor | the object to search for

Returns
  the index of the element, or -1 if it's not found

See also
  addSorted, sort

Definition at line 559 of file juce_OwnedArray.h.

## ◆ insert() [1/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass * juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::insert | ( | int | indexToInsertAt,
|  | ObjectClass * | newObject
| ) |  |
| inline

Inserts a new object into the array at the given index.

Note that this object will be deleted by the OwnedArray when it is removed, so be careful not to delete it somewhere else.

If the index is less than 0 or greater than the size of the array, the element will be added to the end of the array. Otherwise, it will be inserted into the array, moving all the later elements along to make room.

Be careful not to add the same object to the array more than once, as this will obviously cause deletion of dangling pointers.

Parameters

  indexToInsertAt | the index at which the new element should be inserted
  newObject | the new object to add to the array

Returns
  the new object that was added

See also
  add, addSorted, set

Definition at line 336 of file juce_OwnedArray.h.

Referenced by juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::addSorted(), juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::insert(), and juce::UndoManager::perform().

## ◆ insert() [2/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass * juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::insert | ( | int | indexToInsertAt,
|  | std::unique_ptr< ObjectClass > | newObject
| ) |  |
| inline

Inserts a new object into the array at the given index.

Note that this object will be deleted by the OwnedArray when it is removed, so be careful not to delete it somewhere else.

If the index is less than 0 or greater than the size of the array, the element will be added to the end of the array. Otherwise, it will be inserted into the array, moving all the later elements along to make room.

Be careful not to add the same object to the array more than once, as this will obviously cause deletion of dangling pointers.

Parameters

  indexToInsertAt | the index at which the new element should be inserted
  newObject | the new object to add to the array

Returns
  the new object that was added

See also
  add, addSorted, set

Definition at line 361 of file juce_OwnedArray.h.

## ◆ insertArray()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::insertArray | ( | int | indexToInsertAt,
|  | ObjectClass *const * | newObjects,
|  | int | numberOfElements
| ) |  |
| inline

Inserts an array of values into this array at a given position.

If the index is less than 0 or greater than the size of the array, the new elements will be added to the end of the array. Otherwise, they will be inserted into the array, moving all the later elements along to make room.

Parameters

  indexToInsertAt | the index at which the first new element should be inserted
  newObjects | the new values to add to the array
  numberOfElements | how many items are in the array

See also
  insert, add, addSorted, set

Definition at line 378 of file juce_OwnedArray.h.

## ◆ isEmpty()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

bool juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::isEmpty | ( |  | ) | const
| inlinenoexcept

Returns true if the array is empty, false otherwise.

Definition at line 136 of file juce_OwnedArray.h.

## ◆ minimiseStorageOverheads()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::minimiseStorageOverheads | ( |  | ) |
| inlinenoexcept

Reduces the amount of storage being used by the array.

Arrays typically allocate slightly more storage than they need, and after removing elements, they may have quite a lot of unused space allocated. This method will reduce the amount of allocated storage to a minimum.

Definition at line 776 of file juce_OwnedArray.h.

Referenced by juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::remove(), juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeAndReturn(), and juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeRange().

## ◆ move()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::move | ( | int | currentIndex,
|  | int | newIndex
| ) |  |
| inlinenoexcept

Moves one of the objects to a different position.

This will move the object to a specified index, shuffling along any intervening elements as required.

So for example, if you have the array { 0, 1, 2, 3, 4, 5 } then calling move (2, 4) would result in { 0, 1, 3, 4, 2, 5 }.

Parameters

  currentIndex | the index of the object to be moved. If this isn't a valid index, then nothing will be done
  newIndex | the index at which you'd like this object to end up. If this is less than zero, it will be moved to the end of the array

Definition at line 747 of file juce_OwnedArray.h.

## ◆ operator=() [1/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

OwnedArray & juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::operator= | ( | OwnedArray< ObjectClass, TypeOfCriticalSectionToUse > && | other | ) |
| inlinenoexcept

Move assignment operator.

Definition at line 80 of file juce_OwnedArray.h.

## ◆ operator=() [2/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>
template<class OtherObjectClass , class OtherCriticalSection >

OwnedArray & juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::operator= | ( | OwnedArray< OtherObjectClass, OtherCriticalSection > && | other | ) |
| inlinenoexcept

Converting move assignment operator.

Definition at line 97 of file juce_OwnedArray.h.

## ◆ operator[]()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass * juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::operator[] | ( | int | index | ) | const
| inlinenoexcept

Returns a pointer to the object at this index in the array.

If the index is out-of-range, this will return a null pointer, (and it could be null anyway, because it's ok for the array to hold null pointers as well as objects).

See also
  getUnchecked

Definition at line 149 of file juce_OwnedArray.h.

## ◆ remove()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::remove | ( | int | indexToRemove,
|  | bool | deleteObject = `true`
| ) |  |
| inline

Removes an object from the array.

This will remove the object at a given index (optionally also deleting it) and move back all the subsequent objects to close the gap. If the index passed in is out-of-range, nothing will happen.

Parameters

  indexToRemove | the index of the element to remove
  deleteObject | whether to delete the object that is removed

See also
  removeObject, removeRange

Definition at line 598 of file juce_OwnedArray.h.

Referenced by juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeObject().

## ◆ removeAndReturn()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass * juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeAndReturn | ( | int | indexToRemove | ) |
| inline

Removes and returns an object from the array without deleting it.

This will remove the object at a given index and return it, moving back all the subsequent objects to close the gap. If the index passed in is out-of-range, nothing will happen.

Parameters

  indexToRemove | the index of the element to remove

See also
  remove, removeObject, removeRange

Definition at line 629 of file juce_OwnedArray.h.

## ◆ removeLast()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeLast | ( | int | howManyToRemove = `1`,
|  | bool | deleteObjects = `true`
| ) |  |
| inline

Removes the last n objects from the array.

Parameters

  howManyToRemove | how many objects to remove from the end of the array
  deleteObjects | whether to also delete the objects that are removed

See also
  remove, removeObject, removeRange

Definition at line 712 of file juce_OwnedArray.h.

## ◆ removeObject()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeObject | ( | const ObjectClass * | objectToRemove,
|  | bool | deleteObject = `true`
| ) |  |
| inline

Removes a specified object from the array.

If the item isn't found, no action is taken.

Parameters

  objectToRemove | the object to try to remove
  deleteObject | whether to delete the object (if it's found)

See also
  remove, removeRange

Definition at line 655 of file juce_OwnedArray.h.

## ◆ removeRange()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeRange | ( | int | startIndex,
|  | int | numberToRemove,
|  | bool | deleteObjects = `true`
| ) |  |
| inline

Removes a range of objects from the array.

This will remove a set of objects, starting from the given index, and move any subsequent elements down to close the gap.

If the range extends beyond the bounds of the array, it will be safely clipped to the size of the array.

Parameters

  startIndex | the index of the first object to remove
  numberToRemove | how many objects should be removed
  deleteObjects | whether to delete the objects that get removed

See also
  remove, removeObject

Definition at line 682 of file juce_OwnedArray.h.

Referenced by juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeLast().

## ◆ set() [1/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass * juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::set | ( | int | indexToChange,
|  | ObjectClass * | newObject,
|  | bool | deleteOldElement = `true`
| ) |  |
| inline

Replaces an object in the array with a different one.

If the index is less than zero, this method does nothing. If the index is beyond the end of the array, the new object is added to the end of the array.

Be careful not to add the same object to the array more than once, as this will obviously cause deletion of dangling pointers.

Parameters

  indexToChange | the index whose value you want to change
  newObject | the new value to set for this index.
  deleteOldElement | whether to delete the object that's being replaced with the new one

See also
  add, insert, remove

Definition at line 402 of file juce_OwnedArray.h.

Referenced by juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::set().

## ◆ set() [2/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass * juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::set | ( | int | indexToChange,
|  | std::unique_ptr< ObjectClass > | newObject,
|  | bool | deleteOldElement = `true`
| ) |  |
| inline

Replaces an object in the array with a different one.

If the index is less than zero, this method does nothing. If the index is beyond the end of the array, the new object is added to the end of the array.

Be careful not to add the same object to the array more than once, as this will obviously cause deletion of dangling pointers.

Parameters

  indexToChange | the index whose value you want to change
  newObject | the new value to set for this index.
  deleteOldElement | whether to delete the object that's being replaced with the new one

See also
  add, insert, remove

Definition at line 451 of file juce_OwnedArray.h.

## ◆ size()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

int juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::size | ( |  | ) | const
| inlinenoexcept

Returns the number of items currently in the array.

See also
  operator[]

Definition at line 130 of file juce_OwnedArray.h.

Referenced by juce::ZipFile::createStreamForEntry(), juce::ZipFile::getNumEntries(), juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::isEmpty(), juce::MixerAudioSource::removeAllInputs(), juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::sort(), and juce::ZipFile::uncompressTo().

## ◆ sort()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>
template<class ElementComparator >

void juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::sort | ( | ElementComparator & | comparator,
|  | bool | retainOrderOfEquivalentItems = `false`
| ) |  |
| inlinenoexcept

Sorts the elements in the array.

This will use a comparator object to sort the elements into order. The object passed must have a method of the form:

int compareElements (ElementType* first, ElementType* second);

..and this method must return:

- a value of < 0 if the first comes before the second
- a value of 0 if the two objects are equivalent
- a value of > 0 if the second comes before the first

To improve performance, the compareElements() method can be declared as static or const.

Parameters

  comparator | the comparator to use for comparing elements.
  retainOrderOfEquivalentItems | if this is true, then items which the comparator says are equivalent will be kept in the order in which they currently appear in the array. This is slower to perform, but may be important in some cases. If it's false, a faster algorithm is used, but equivalent elements may be rearranged.

See also
  sortArray, indexOfSorted

Definition at line 821 of file juce_OwnedArray.h.

Referenced by juce::ValueTree::sort().

## ◆ swap()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::swap | ( | int | index1,
|  | int | index2
| ) |  |
| inlinenoexcept

Swaps a pair of objects in the array.

If either of the indexes passed in is out-of-range, nothing will happen, otherwise the two objects at these positions will be exchanged.

Definition at line 728 of file juce_OwnedArray.h.

## ◆ swapWith()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>
template<class OtherArrayType >

void juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::swapWith | ( | OtherArrayType & | otherArray | ) |
| inlinenoexcept

This swaps the contents of this array with those of another array.

If you need to exchange two arrays, this is vastly quicker than using copy-by-value because it just swaps their internal pointers.

Definition at line 762 of file juce_OwnedArray.h.

## Member Data Documentation

## ◆ deleteAllObjects

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

JUCE_DEPRECATED_WITH_BODY(void swapWithArray(OwnedArray &other) noexcept, { swapWith(other);}) private void juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::deleteAllObjects()
| inline

Definition at line 855 of file juce_OwnedArray.h.

The documentation for this class was generated from the following file:

- juce_OwnedArray.h